﻿
window.addEventListener("DOMContentLoaded", init);
var TMan = new N6LTimerMan();  //タイマーマネージャー
var boxies = [];
var renderer;
var camera;
var scene;

function init() {
  const width = 500;
  const height = 250;

  renderer = new THREE.WebGLRenderer({
    canvas: document.querySelector("#cnv0")
  });
  renderer.setPixelRatio(window.devicePixelRatio);
  renderer.setSize(width, height);
  scene = new THREE.Scene();
  camera = new THREE.PerspectiveCamera(
    45,
    width / height,
    1,
    10000
  );
  camera.position.set(0, 0, 20);

  // 箱を作成
  const geometry = new THREE.BoxGeometry(5, 5, 5);
  const loader = new THREE.TextureLoader();
  const texture = loader.load('./img/koala.jpg');
  const textureF = loader.load('./img/koalaF.jpg');
  // マテリアルにテクスチャーを設定
  const materials = [
    new THREE.MeshStandardMaterial({map: textureF}),
    new THREE.MeshStandardMaterial({map: texture}),
    new THREE.MeshStandardMaterial({map: texture}),
    new THREE.MeshStandardMaterial({map: texture}),
    new THREE.MeshStandardMaterial({map: texture}),
    new THREE.MeshStandardMaterial({map: texture})
  ];
  for(i = 0; i < 9; i++) {
    var box = new THREE.Mesh( geometry, materials );
    box.position.set(((i % 3) - 1) * 500, 0, Math.floor(i / 3) * 500);
    scene.add( box );
    boxies.push( box );
  }

  path = "./img/skybox";
  format = '.jpg';
  urls = [
    path + 'px' + format, path + 'nx' + format,
    path + 'py' + format, path + 'ny' + format,
    path + 'pz' + format, path + 'nz' + format
  ];

  tCube = new THREE.CubeTextureLoader().load( urls );
  scene.background = tCube;


  // 平行光源
  const light = new THREE.DirectionalLight(0xffffff);
  light.intensity = 2; // 光の強さを倍に
  light.position.set(1, 1, 1);
  // シーンに追加
  scene.add(light);

  TMan.add();
  TMan.timer[0].setalerm(function() { Loop(0); }, 50);  //メインループセット


 
  function Loop(id) {
    var i;
    for(i = 0; i < 9; i++) {
        boxies[i].rotation.x += 1.0 * Math.PI / 180.0;//x軸回りに1度回転
        boxies[i].rotation.y += 2.0 * Math.PI / 180.0;//y軸回りに2度回転
        boxies[i].rotation.z += 3.0 * Math.PI / 180.0;//z軸回りに3度回転
    }

    moveobj();

    // レンダリング
    renderer.render(scene, camera);

    TMan.timer[id].setalerm(function() { Loop(id); }, 50);  //メインループセット
  }

}

//オブジェクト位置情報
//位置4*4マトリクス(継続パラメータ)
var A = false;

//速度(継続パラメータ)
var V = 0.1;
var a = 0;
var pyr = new N6LVector([1, 0, 0, 0], true); 
var la = new N6LVector(4, true).UnitVec(3); 
var up = new N6LVector(4, true).UnitVec(2); 

//以上のように初期化してから、下の関数を呼び続ける

//加速度a,(スカラー量)(新規パラメータ) 
//ピッチヨーロール(1, θp, θy, θr)(新規パラメータ) 

function moveobj() {

  if(!A) {
    var Proj = camera.projectionMatrix;
    A = new N6LVector([Proj.elements[15], Proj.elements[12], Proj.elements[13], Proj.elements[14]], true); 
  }

  var B = la.Mul(a);              //カメラ平行移動行
  var az = new N6LVector(la);     //カメラZ軸行
  var ay = new N6LVector(up);     //カメラY軸行
  var ax = az.Cross(ay);          //カメラX軸行

  //カメラワールド行列
  var matWK = new N6LMatrix([B,ax,ay,az]);
  matWK = matWK.NormalMat();

  //ヨーピッチロール回転
  matWK = matWK.RotAxis(az, pyr.x[3] * -1.0);
  matWK = matWK.RotAxis(ay, pyr.x[2] * -1.0);
  matWK = matWK.RotAxis(ax, pyr.x[1] * -1.0);


  //update
  B = new N6LVector(matWK.x[0]);
  B = B.SetHomo(true);
  la = new N6LVector(matWK.x[3]);
  la = la.SetHomo(true);
  up = new N6LVector(matWK.x[2]);
  up = up.SetHomo(true);
  //C = カメラ位置＋カメラZ軸＋更新されたカメラZ軸
  A = A.Add(B);
  var C = A.Add(la);
  //reset
  pyr = new N6LVector([1, 0, 0, 0], true); 

  //set up
  camera.position.set(A.x[1], A.x[2], A.x[3]);
  camera.up.set(up.x[1], up.x[2], up.x[3]);
  camera.lookAt(C.x[1], C.x[2], C.x[3]);
}


/*
function moveobj() {

  if(!A) {
    var Proj = camera.projectionMatrix;
    A = new N6LVector([Proj.elements[15], Proj.elements[12], Proj.elements[13], Proj.elements[14]], true); 
  }

  var B = la.Mul(a);              //カメラ平行移動行
  var az = new N6LVector(la);     //カメラZ軸行
  var ay = new N6LVector(up);     //カメラY軸行
  var ax = az.Cross(ay);          //カメラX軸行

  B = B.RotAxis(az, pyr.x[3]);
  B = B.RotAxis(ay, pyr.x[2]);
  B = B.RotAxis(ax, pyr.x[1]);

  la = la.RotAxis(az, pyr.x[3]);
  la = la.RotAxis(ay, pyr.x[2]);
  la = la.RotAxis(ax, pyr.x[1]);

  up = up.RotAxis(az, pyr.x[3]);
  up = up.RotAxis(ay, pyr.x[2]);
  up = up.RotAxis(ax, pyr.x[1]);

  A = A.Add(B);

  var C = A.Add(la);


  pyr = new N6LVector([1, 0, 0, 0], true); 

  camera.position.set(A.x[1], A.x[2], A.x[3]);
  camera.up.set(up.x[1], up.x[2], up.x[3]);        // set up
  camera.lookAt(C.x[1], C.x[2], C.x[3]);

}
*/



//キー入力
var KBLock7 = 0;
var KBLock9 = 0;
var KBIntvl = 5;
function chkKeyBoard(){
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N1'))]) {//N1Key
    pyr.x[3] -= 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N2'))]) {//N2Key
    pyr.x[1] += 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N3'))]) {//N3Key
    pyr.x[3] += 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N4'))]) {//N4Key
    pyr.x[2] += 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N5'))]) {//N5Key
    a = 0;
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N6'))]) {//N6Key
    pyr.x[2] -= 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N7'))]) {//N7Key
    if(KBIntvl < KBLock7) KBLock7 = 0;
    if(KBLock7 == 0) {
      a -= 0.5;
      if(a < -50) a = -50;
    }
    KBLock7++;
  }
  else KBLock7 = 0;
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N8'))]) {//N8Key
    pyr.x[1] -= 1 * (Math.PI / 180);
  }
  if(KeyB.keystate[KeyB.indexof(KeyB.ToReal('VK_N9'))]) {//N9Key
    if(KBIntvl < KBLock9) KBLock9 = 0;
    if(KBLock9 == 0) {
      a += 0.5;
      if(50 < a) a = 50;
    }
    KBLock9++;
  }
  else KBLock9 = 0;
};

